#include <Adxl345.h>
#include <math.h>
#include <TimerOne.h>

Accelerometer accel(10);

int STBY = 6; //standby

//Motor A
int PWMA = 3; //Speed control
int AIN1 = 9; //Direction
int AIN2 = 8; //Direction

//Motor B
int PWMB = 5; //Speed control
int BIN1 = 7; //Direction
int BIN2 = 4; //Direction

float y = 0;
float derror;
float ctrl;

int motorPwr;

float lasterror = 0;
float interror = 0;

void setup() {
  pinMode(STBY, OUTPUT);

  pinMode(PWMA, OUTPUT);
  pinMode(AIN1, OUTPUT);
  pinMode(AIN2, OUTPUT);

  pinMode(PWMB, OUTPUT);
  pinMode(BIN1, OUTPUT);
  pinMode(BIN2, OUTPUT);

  pinMode(AIN2, OUTPUT);
  pinMode(AIN2, OUTPUT);

  digitalWrite(STBY, HIGH); //disable standby

  Timer1.initialize(50000);
  Timer1.attachInterrupt(intr);
  accel.powerOn();

  Serial.begin(9600);
}

float kp = 9.4;
float kd = 1.1;//0.04;//
float ki = 0.001;//12;//10;

void intr(void)
{
  if (interror > 25 || interror < -25)
  {
    interror = 0;
  }

  derror = (-y - lasterror) / 0.05;
  interror += -y * 0.1;
  ctrl =  -y * kp + derror*kd + ki*interror; 
  //Serial.println(interror);  
  motorPwr = (abs(ctrl) > 255) ? 255 : abs(ctrl);

  //move(1, motorPwr, (ctrl < 0) ? 1 : 0); //motor 1, full speed, left
  //move(2, motorPwr, (ctrl < 0) ? 1 : 0); //motor 2, full speed, left

  lasterror = -y;
}

void loop() {
  move(1, motorPwr, (ctrl < 0) ? 1 : 0); //motor 1, full speed, left
  move(2, motorPwr, (ctrl < 0) ? 1 : 0); //motor 2, full speed, left
  

  int  xread,yread,zread;
  accel.readAccel(&xread, &yread, &zread);
  y = -(atan2(zread,yread) * 180 / PI) - 9;
}


void move(int motor, int speed, int direction) {
  //Move specific motor at speed and direction
  //motor: 0 for B 1 for A
  //speed: 0 is off, and 255 is full speed
  //direction: 0 clockwise, 1 counter-clockwise
  boolean inPin1 = LOW;
  boolean inPin2 = HIGH;

  if (direction == 1) {
    inPin1 = HIGH;
    inPin2 = LOW;
  }

  if (motor == 1) {
    digitalWrite(AIN1, inPin1);
    digitalWrite(AIN2, inPin2);
    analogWrite(PWMA, speed);
  } else {
    digitalWrite(BIN1, inPin1);
    digitalWrite(BIN2, inPin2);
    analogWrite(PWMB, speed);
  }
}

void stop() {
  //enable standby
  digitalWrite(STBY, LOW);
}
